//**********************************************************
//
//	Simplified Logic Anayzer
//
//		This Logic Analizer never analyze your logic.
//		Just log your data. Please call me "Logic Scope".
//
//	Copyright 2009, Yoshi Hiroshi, All rights reserved
//
//**********************************************************

#include <avr/io.h>
#include <avr/interrupt.h>
#include "logicScope.h"
#include "logCommand.h"
#include "uart.h"
#include "commMsg.h"

logControl lcb;

//================================
#if defined (__AVR_ATmega644P__)
unsigned char logBuffer[LOG_DATA_BUFFER_SIZE];
#endif
//================================

////////////////////////////////////////////////////////////

//**********************************************************
//		Comamnd Analysis and Execution
//**********************************************************
//
//----------------------------------------------------------
void doCommand()
{
	for(unsigned char index = 0; index < COMMAND_BUFFER_SIZE; lcb.commandBuffer[index++] = 0);
	lcb.commandBuffer[0] = readUART_1();
	switch(lcb.commandBuffer[0])
	{
		case COMMAND_CHECK:	// check
			doCheckCommand();
			break;
		case COMMAND_START:	// start
			doStartCommand();
			break;
		case COMMAND_LOGCOND:	// get data
			doGetLogConditonCommand();
			break;
		case COMMAND_GETDATA:	// get data
			doGetLogDataCommand();
			break;
		default:
			break;
	}
}

//**********************************************************
//
//**********************************************************
ISR(LOG_STOP_INT_vect)
{
	if(IS_LOG_BUSY)
	{
		lcb.logCounter = 1;
		lcb.TriggerMask = 0;
		lcb.dataReady = 1;
	}
	LOG_STOP_INT_DISABLE;
}

//**********************************************************
//
//**********************************************************
//
//----------------------------------------------------------
int main(void)
{
#if defined (__AVR_ATmega644P__)
	CLKPR = _BV(CLKPCE);
	CLKPR = 0;								// NbN𕪎Ȃ
#endif

	LOGDATA_PORT_INIT;						// PORTA̓|[gɂ
	BAUD_RATE_OPTION_INIT;					// BAUD RATE ݒs̓|[gɂ
	LOGSTATUS_LED_DDR_INIT;
	BUSY_LED_WAIT_TRIGGER_OFF;
#if defined (__AVR_ATmega128__)
	MCUCR |= _BV(SRE);
	DDRG |= 0x08;
	PORTD &= 0xF7;
#endif

// init log control block
	lcb.busy = 0;
	lcb.HardwareMask = HARDWARE_BIT_MASK;	// n[hEFA}XN̏i644P,1280xFFj
	lcb.TriggerMask = 0x00;					// gK[}XN̏
	lcb.TriggerPattern = 0x00;				// gK[p^[̏
#if defined (__AVR_ATmega644P__)
	lcb.buff = logBuffer;					// obt@AhX̐ݒ
#endif
#if defined (__AVR_ATmega128__)
	lcb.buff = (unsigned char*)0x1100;					// obt@AhX̐ݒ
#endif
	lcb.buffSize = LOG_DATA_BUFFER_SIZE;	// obt@TCY̐ݒ
	lcb.dataReady = 0;

	initUART();								// USART̏
	for(int loop = 0; loop < 10; loop++)	// N̉LED_
	{
		BUSY_LED_WAIT_TRIGGER_INV;			// LED]
		for(volatile long wait = 0; wait < 100000; wait++);	// LED_Ŏ
	}
	LOG_STOP_INT_INIT;					// WIpÕ݂}XNݒiRXDωŊ݁j
	sei();

//	Log_200_Cycle();	// 10uS
//	Log_100_Cycle();	// 5uS
//	Log_40_Cycle();		// 2uS
//	Log_20_Cycle();
//	Log_10_Cycle();
//	Log_4_Cycle();
//	Log_3_Cycle();
//	lcb.period = 20000;  normalLog();	// 20uS	400/320 cycle
//	lcb.period = 50000;  normalLog();	// 50uS	1000 cycle
//	lcb.period = 100000; normalLog();	// 100uS 2000 cycle

	while(1)
	{
		if(checkReceiveUART())
			doCommand();
	}
}

